#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_ActivityCarnivalFullCFG.h"
std::auto_ptr<M_ActivityCarnivalFullCFG> M_ActivityCarnivalFullCFG::msSingleton(nullptr);

int M_ActivityCarnivalFullCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivityCarnivalFullCFGData* M_ActivityCarnivalFullCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_ActivityCarnivalFullCFGData>& M_ActivityCarnivalFullCFG::GetMapData()
{
	return mMapData;
}

void M_ActivityCarnivalFullCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_ActivityCarnivalFullCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivityCarnivalFullCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mDsc = element->Attribute("Dsc");
		data.mNeedRecharged = element->IntAttribute("NeedRecharged");
		data.mBigRedId = element->IntAttribute("BigRedId");
		{
			const char* BigRedIntegral = element->Attribute("BigRedIntegral");
			std::vector<std::string> vecBigRedIntegral;
			boost::split(vecBigRedIntegral, BigRedIntegral, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecBigRedIntegral.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecBigRedIntegral[i].c_str(), &temp))
				{
					data.mBigRedIntegral.push_back(temp);
				}
			}
		}
		{
			const char* BigRedDisplay = element->Attribute("BigRedDisplay");
			std::vector<std::string> vecBigRedDisplay;
			boost::split(vecBigRedDisplay, BigRedDisplay, boost::is_any_of(","));
			for (unsigned int i = 0; i < vecBigRedDisplay.size(); i++)
			{
				data.mBigRedDisplay.push_back(vecBigRedDisplay[i]);
			}
		}
		{
			const char* AwardItemIDs = element->Attribute("AwardItemIDs");
			std::vector<std::string> vecAwardItemIDs;
			boost::split(vecAwardItemIDs, AwardItemIDs, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecAwardItemIDs.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecAwardItemIDs[i].c_str(), &temp))
				{
					data.mAwardItemIDs.push_back(temp);
				}
			}
		}
		{
			const char* AwardItemCounts = element->Attribute("AwardItemCounts");
			std::vector<std::string> vecAwardItemCounts;
			boost::split(vecAwardItemCounts, AwardItemCounts, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecAwardItemCounts.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecAwardItemCounts[i].c_str(), &temp))
				{
					data.mAwardItemCounts.push_back(temp);
				}
			}
		}
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_ActivityCarnivalFullCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ActivityCarnivalFullCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_ActivityCarnivalFullCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_ActivityCarnivalFullCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_ActivityCarnivalFullCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readString(L, "Dsc", data.mDsc);
		LuaCfgHelper::readInt(L, "NeedRecharged", data.mNeedRecharged);
		LuaCfgHelper::readInt(L, "BigRedId", data.mBigRedId);
		LuaCfgHelper::readVectorInt(L, "BigRedIntegral", data.mBigRedIntegral);
		LuaCfgHelper::readVectorString(L, "BigRedDisplay", data.mBigRedDisplay);
		LuaCfgHelper::readVectorInt(L, "AwardItemIDs", data.mAwardItemIDs);
		LuaCfgHelper::readVectorInt(L, "AwardItemCounts", data.mAwardItemCounts);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_ActivityCarnivalFullCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ActivityCarnivalFullCFG::Reload()
{
	mMapData.clear();
	Load();
}

M_ActivityCarnivalFullCFG* M_ActivityCarnivalFullCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivityCarnivalFullCFG());
	}
	return msSingleton.get();
}

void M_ActivityCarnivalFullCFG::Release()
{
	msSingleton.reset(nullptr);
}
